/*
 * Created on 2007/03/06
 *
 *
 * Copyright(c) 2007 Yoshimasa Matsumoto
 */
package netjfwatcher.jmx.gui.snmp;

import java.util.logging.Logger;

import netjfwatcher.engine.filepreference.FilePreference;
import netjfwatcher.snmp.mibtree.AbstractMibTree;



/**
 * JMX MIB`CSVt@C͂AOID Tree𐶐NXłB
 *
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public final class ManagerJMXSnmpMibTree extends AbstractMibTree {
    /* MO */
    private static Logger logger;

    /**
     * wMIB`t@COID Tree𐶐NXCX^X
     * ܂B
     *
     * @param fileName MIB`t@C
     */
    private ManagerJMXSnmpMibTree(String fileName) {
        logger = Logger.getLogger(this.getClass().getName());

        this.parseCSVFile(fileName);
    }

    /**
     *
     *
     * @param fileName
     */
    public void reloadOidTree(String fileName) {
        logger.info("Reload OID define file : " + fileName);

        oidList.clear();
        oidHashMap.clear();
        mibDescripHashMap.clear();

        rootTreeNode = null;

        this.parseCSVFile(fileName);
    }

    /**
     * ̃NX̃CX^XԂ܂B<BR>
     * iNXێĂVOgEIuWFNg
     * Ԃ܂j<BR>
     *
     * @return VOgEIuWFNgƂĂ̂̃NX
     * CX^X
     */
    public static ManagerJMXSnmpMibTree getInstance() {
        return SingletonResource.RESOURCE;
    }

    /**
     * VOgEIuWFNgێNXłB<BR>
     *
     */
    private static class SingletonResource {
        static final ManagerJMXSnmpMibTree RESOURCE =
            new ManagerJMXSnmpMibTree(FilePreference.JMX_MIB_DEFINE_FILE);
    }
}
